<?php
require_once("config.php");
require_once("functions.php");
require_once("system.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("http.php");
require_once("secure/secure-functions.php");
require_once("secure/secure.php");

include("headerbs.php");

echo "<div class='wrap'>\n";

require_once("dbconn.php");

include("menu.php");

echo "<div class='content'>\n";

$fop2_mirror   = getFastestMirror();

// Check online version
$fop2managerxml = uHttp::sendHttpRequest("http://".$fop2_mirror."/plugins/fop2manager.xml", 5);

$xmlobj        = simplexml_load_string($fop2managerxml);
$versiononline = $xmlobj->version;
$changelog     = $xmlobj->changelog;
$rawname       = $xmlobj->rawname;
$changelog     = preg_replace("/\n/","<br/>",$changelog);
$adminfile     = $rawname."-".$versiononline;

$versioncompare='';
$version_partes = preg_split("/\./",$version);
foreach($version_partes as $part) {
    $versioncompare.=sprintf("%02d",$part);
}

$versiononlinecompare='';
$versiononline_partes = preg_split("/\./",$versiononline);
foreach($versiononline_partes as $part) {
    $versiononlinecompare.=sprintf("%02d",$part);
}

$querycreate['fop2buttons'] = "CREATE TABLE IF NOT EXISTS `fop2buttons` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `exclude` int(2) NOT NULL default '0',
    `sortorder` int(6) NOT NULL default '0',
    `type` varchar(40) NOT NULL,
    `device` varchar(100) NOT NULL,
    `privacy` varchar(30) default NULL,
    `label` varchar(100) default NULL,
    `group` varchar(60) NOT NULL default '',
    `exten` varchar(30) default NULL,
    `email` varchar(100) NOT NULL default '',
    `context` varchar(100) default NULL,
    `mailbox` varchar(100) default NULL,
    `channel` varchar(200) default '',
    `queuechannel` text default '',
    `originatechannel` varchar(200) default '',
    `customastdb` varchar(50) default '',
    `spyoptions` varchar(100) default '',
    `external` varchar(100) default '',
    `tags` varchar(255) default '',
    PRIMARY KEY  (`id`),
    UNIQUE KEY `devname` (`device`)
   ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2users'] = "CREATE TABLE IF NOT EXISTS `fop2users` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `exten` varchar(30) NOT NULL,
    `secret` varchar(20) NOT NULL,
    `permissions` varchar(200) default NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `extctx` (`exten`,`context_id`)
   ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2groups'] = "CREATE TABLE IF NOT EXISTS `fop2groups` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `name` varchar(50) NOT NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `name` (`name`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2templates'] = "CREATE TABLE IF NOT EXISTS `fop2templates` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `name` varchar(30) default NULL,
    `permissions` varchar(200) default NULL,
    `groups` varchar(200) default NULL,
    `plugins` varchar(200) default NULL,
    `isdefault` int(6) default '0',
    PRIMARY KEY  (`id`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2permissions'] = "CREATE TABLE IF NOT EXISTS `fop2permissions` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `name` varchar(30) default NULL,
    `permissions` varchar(200) default NULL,
    PRIMARY KEY  (`id`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2settings'] = "CREATE TABLE IF NOT EXISTS `fop2settings` (
    `id` int(11) NOT NULL auto_increment,
    `keyword` varchar(250) NOT NULL,
    `value` text NOT NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `kw` (`keyword`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2plugins'] = "CREATE TABLE IF NOT EXISTS `fop2plugins` (
    `id` int(11) NOT NULL auto_increment,
    `rawname` varchar(50) default NULL,
    `name` varchar(100) default NULL,
    `version` varchar(10) default NULL,
    `description` tinytext,
    `global` int(11) default '0',
    PRIMARY KEY  (`id`),
    UNIQUE KEY `rname` (`rawname`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2GroupButton'] = "CREATE TABLE IF NOT EXISTS `fop2GroupButton` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `group_name` varchar(50) default NULL,
    `id_button` int(11) NOT NULL,
    PRIMARY KEY  (`id`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2UserGroup'] = "CREATE TABLE IF NOT EXISTS `fop2UserGroup` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `exten` varchar(30) NOT NULL,
    `id_group` int(11) NOT NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `uni` (`exten`,`id_group`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2PermGroup'] = "CREATE TABLE IF NOT EXISTS `fop2PermGroup` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `name` varchar(30) default NULL,
    `id_group` int(11) default NULL,
    `name_group` varchar(100) default NULL,
    PRIMARY KEY  (`id`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2UserPlugin'] = "CREATE TABLE IF NOT EXISTS `fop2UserPlugin` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `exten` varchar(30) default NULL,
    `id_plugin` varchar(50) default NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `uni` (`exten`,`id_plugin`)
  ) DEFAULT CHARSET=UTF8;";

$querycreate['fop2UserContext'] = "CREATE TABLE `fop2UserContext` (
  `id_user` int(11) NOT NULL,
  `id_context` int(11) default NULL,
  PRIMARY KEY  (`id_user`)
) DEFAULT CHARSET=UTF8;";

$querycreate['fop2ButtonContext'] = "CREATE TABLE `fop2ButtonContext` (
  `id_button` int(11) NOT NULL,
  `id_context` int(11) default NULL,
  PRIMARY KEY  (`id_button`)
) DEFAULT CHARSET=UTF8;";

$querycreate['fop2contexts'] = " CREATE TABLE `fop2contexts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `context` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ctx` (`context`)
) DEFAULT CHARSET=UTF8;";

$querycreate['fop2UserTemplate'] = "CREATE TABLE IF NOT EXISTS `fop2UserTemplate` (
    `id` int(11) NOT NULL auto_increment,
    `context_id` int(11) NOT NULL,
    `exten` varchar(30) NOT NULL,
    `id_template` int(11) NOT NULL,
    PRIMARY KEY  (`id`),
    UNIQUE KEY `uni` (`exten`,`id_template`)
  ) DEFAULT CHARSET=UTF8;";

$insert_new_users   = 0;
$insert_new_buttons = 0;

// Check if tables exists, if not create them
foreach($querycreate as $table=>$query) {
    if($db->is_connected()) {
        $res = $db->consulta("DESC $table");
        if(!$res) {
            $ras = $db->consulta($query);
            if(!$ras) {
                echo  "<div class='alert alert-danger alert-dismissable'>";
                echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
                echo sprintf(__("Error creating table %s!"), $table);
                echo "</div>\n";
            } else {
                echo  "<div class='alert alert-success alert-dismissable'>";
                echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
                echo sprintf( __('Table %s created successfully'), $table );
                echo "</div>";
                if($table == 'fop2buttons') { $insert_new_buttons = 1; }
                if($table == 'fop2users')   { $insert_new_users   = 1; }
            }
        }
    }
}

if($db->is_connected()) {

    $updated_field = array();
    $alldbfields   = array();

    $alldbfields['fop2buttons']['customastdb']= "ALTER TABLE `fop2buttons` ADD `customastdb` varchar(50) default '' AFTER originatechannel";
    $alldbfields['fop2buttons']['spyoptions'] = "ALTER TABLE `fop2buttons` ADD `spyoptions` varchar(100) default '' AFTER customastdb";
    $alldbfields['fop2buttons']['channel']    = "ALTER TABLE `fop2buttons` ADD `channel` varchar(200) default '' AFTER mailbox";
    $alldbfields['fop2buttons']['external']   = "ALTER TABLE `fop2buttons` ADD `external` varchar(100) default '' AFTER spyoptions";
    $alldbfields['fop2buttons']['exclude']    = "ALTER TABLE `fop2buttons` ADD `exclude` int(2) NOT NULL default 0 AFTER id";
    $alldbfields['fop2buttons']['tags']       = "ALTER TABLE `fop2buttons` ADD `tags` varchar(255) default '' AFTER external";
    $alldbfields['fop2buttons']['sortorder']  = "ALTER TABLE `fop2buttons` ADD `sortorder` int(6) NOT NULL default 0 AFTER exclude";
    $alldbfields['fop2buttons']['cssclass']   = "ALTER TABLE `fop2buttons` ADD `cssclass` varchar(200) NOT NULL default '' AFTER tags";
    $alldbfields['fop2buttons']['queuecontext']   = "ALTER TABLE `fop2buttons` ADD `queuecontext` varchar(200) NOT NULL default '' AFTER tags";
    $alldbfields['fop2buttons']['extenvoicemail'] = "ALTER TABLE `fop2buttons` ADD `extenvoicemail` varchar(200) NOT NULL default '' AFTER tags";
    $alldbfields['fop2templates']['plugins']      = "ALTER TABLE `fop2templates` ADD `plugins` varchar(200) default ''";

    $alldbfields['fop2buttons']['context_id'] = "ALTER TABLE `fop2buttons` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2users']['context_id'] = "ALTER TABLE `fop2users` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2groups']['context_id'] = "ALTER TABLE `fop2groups` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2permissions']['context_id'] = "ALTER TABLE `fop2permissions` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2templates']['context_id'] = "ALTER TABLE `fop2templates` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2users']['context_id'] = "ALTER TABLE `fop2users` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2GroupButton']['context_id'] = "ALTER TABLE `fop2GroupButton` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2UserPlugin']['context_id'] = "ALTER TABLE `fop2UserPlugin` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2UserGroup']['context_id'] = "ALTER TABLE `fop2UserGroup` ADD `context_id` int(11) NOT NULL AFTER id";
    $alldbfields['fop2PermGroup']['context_id'] = "ALTER TABLE `fop2PermGroup` ADD `context_id` int(11) NOT NULL AFTER id";

    $populate_after_alter['fop2buttons']['customastdb'] = "UPDATE fop2buttons SET customastdb=CONCAT('CF/',exten) WHERE type='extension'";
    $populate_after_alter['fop2buttons']['queuecontext'] = "UPDATE fop2buttons SET queuecontext='from-queue' WHERE type='extension'";
    $populate_after_alter['fop2buttons']['extenvoicemail'] = "UPDATE fop2buttons SET extenvoicemail=IF(mailbox<>'',CONCAT('*',exten),'') WHERE type='extension'";

    foreach($alldbfields as $table => $rest) {

        $res = $db->consulta("DESC $table");

        if($res) {

            // Table exists, check if we need to add /update_fields to it
            $existdbfield = array();
            while($row = $db->fetch_assoc($res)) {
                $campo = $row['Field'];
                $existdbfield[$campo]=1;
            }

            foreach($rest as $campo=>$query) {
                if(!isset($existdbfield[$campo])) {
                    $db->consulta($query);
                    $updated_field[$table][$campo]=1;
                    if($DEBUG==1) {
                        echo "<div class='alert alert-success alert-dismissable'>\n";
                        echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
                        echo sprintf( __('Field %s added to table %s'), $campo, $table );
                        echo "</div>";
                    }
                }
            }
        }
    }

    foreach($updated_field as $table=>$rest) {
        foreach($rest as $field=>$nada) {
            if(isset($populate_after_alter[$table][$field])) {
                $db->consulta($populate_after_alter[$table][$field]);
                if($DEBUG==1) {
                    echo "<div class='alert alert-success alert-dismissable'>\n";
                    echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
                    echo sprintf( __('Field %s from table %s populated with data from backend'), $field, $table );
                    echo "</div>";
                }
            }
        }
    }

    plugin_insert_missing_db();


    if($insert_new_buttons == 1) {
        // INSERTAR BOTONES NUEVOS
        $system_buttons = system_all_buttons();
        $cont=0;
        foreach($system_buttons as $chan=>$dat) {
            $cont++;
            fop2_add_button($dat);
        }
        if($cont>0) {
            echo "<div class='alert alert-success alert-dismissable'>\n";
            echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
            echo sprintf( __('%s buttons added'), $cont );
            echo "</div>";
         }
    }

    if($insert_new_users == 1) {

        $extensctx  = array();
        $vmpins     = system_all_values('vmpin');
        $extensions = system_all_values('exten');
        $types      = system_all_values('type');
        $pnlctx     = system_all_values('context_id');
        foreach ($types as $chan=>$type) {
            if($type=='extension') {
                if(isset($vmpins[$chan])) {
                    $extensctx[$pnlctx[$chan]][$extensions[$chan]]=$vmpins[$chan];
                } else {
                    $extensctx[$pnlctx[$chan]][$extensions[$chan]]=$extensions[$chan];
                }
            }
        }

        foreach($extensctx as $pnlctx=>$extens) {
            ksort($extens);
            $permisos='all';
            $cont=0;
            foreach($extens as $exten=>$clave) {
                $cont++;
                $results = $db->consulta("INSERT INTO fop2users (exten,secret,permissions,context_id) VALUES ('$exten','$clave','$permisos','$pnlctx')");
                $permisos="dial,transfer,transferexternal,pickup,phonebook,preferences,hangupself,chat";
                $results = $db->consulta("INSERT INTO fop2UserGroup (exten,id_group,context_id) VALUES ('$exten',-1,'$pnlctx')","query");
            }
            if($cont>0) {
                echo  "<div class='alert alert-success alert-dismissable'>\n";
                echo "<button type='button' class='close' data-dismiss='alert' aria-hidden='true'>&times;</button>\n";
                echo sprintf( __('%s users added'), $cont );
                echo "</div>";
            }
        }
    }

}

if(is_file('asteriskreload.php')) {
    unlink('asteriskreload.php');
}

// End of Create or Update Databases
echo "<h2>".__("Welcome")."</h2>";
echo "<p>";
echo __("The FOP2 Manager lets you configure users, permissions, button details and options. It will also let you install, uninstall and configure FOP2 plugins. It will read data from your configuration backend (FreePBX, Thirdlane, etc) and populate its own tables with your preferences.");
echo "</p>";
echo "<hr/>";

$licensedplugins=explode(',',plugin_get_licensed());

echo "<div class='row'>\n";

// Check for new versions
if($versiononlinecompare > $versioncompare) {
    echo "<div class='col-md-12'>\n";
    echo "<div class='panel panel-warning'>\n";
    echo "<div class='panel-heading'>\n";
    echo "<h3 class='panel-title'>\n";
    echo __("Upgrade Available");
    echo "</h3>\n";
    echo "</div>\n";
    echo "<div class='panel-body'>\n";
    echo "<a class='ttip' href='#' id='chlogbtn' onclick='togglechangelog()' data-toggle='popover' data-trigger='hover' data-placement='bottom' data-content='";
    echo __('Show Changelog');
    echo "'><span class='glyphicon glyphicon-collapse-down' id='chlogicon'></span></a>&nbsp;";
    echo sprintf(__('New %s version %s available for download'),$APPNAME,$versiononline);
    echo " ";
    echo sprintf(__('(Your current version is %s)'),$version);
    echo "<button class='btn btn-warning pull-right' id='upgradeBtn' >".__('Upgrade')."</button>";
    echo "<div id='changelog' style='display:none;'>";
    echo "<hr/>\n";
    echo __('Changelog');
    echo $changelog;
    echo "</div>\n";
    echo "</div>\n";
    echo "</div>\n";
    echo "</div>\n";
}

echo "<div class='col-md-6'>\n";
// This is to check if FOP2 Server is running
if($licensedplugins[0] == '0') {
    echo "<div class='alert alert-danger'>";
    echo __("FOP2 Server is not responding. Be sure the service is running!");
    echo "</div>\n";
} else {
    echo "<div class='alert alert-success'>";
    echo "<strong>".__("FOP2 Server Status: OK")."</strong>";
    echo "</div>\n";
}
echo "</div>";

// This shows the backend engine
echo "<div class='col-md-6'>\n";
echo "<div class='alert alert-success'><strong>";
echo sprintf( __('Backend Engine: %s'), $config_engine );
echo "</strong></div>\n";
echo "</div>";
echo "</div>";

if($licensedplugins[0] <> '0') {

    // FOP2 Server is running, list licensed plugins if any

    $plugin_online = plugin_get_online($fop2_mirror);

    if (isset($plugin_online)) {
	    foreach ($plugin_online as $idx=>$arrdata) {
            $plugin_name[$arrdata['rawname']]=$arrdata['name'];
        }
    }

    if($licensedplugins[0]<>'') {
        echo "<div class='panel panel-success'>\n";
        echo "<div class='panel-heading'><h3 class='panel-title'>\n";
        echo __("Licensed Plugins");
        echo "</h3></div>";
        echo "<div class='panel-body'>";
        foreach($licensedplugins as $rawname) {
            echo $plugin_name[$rawname]."<br>";
        }
        echo "</div>";
        echo "</div>";
    } else {
        echo  "<div class='alert alert-warning'>";
        echo __("There are no licensed plugins");
        echo "</div>\n";
    }

}

if($db->is_connected()) {
    // Information on Home
    echo "<div class='row'>\n";

    echo "<div class='col-md-3'>\n";
    $res = $db->consulta("SELECT count(*) FROM fop2users");
    $row = $db->fetch_row($res);
    $cont = $row[0];
    echo "<div class='panel panel-info'>\n";
    echo "<div class='panel-heading'><h3 class='panel-title'>".__('Users')."</h3></div>\n";;
    echo "<div class='panel-body'><h2 class='text-center'>";
    echo $cont;
    echo "</h2></div>";
    echo "</div>";
    echo "</div>";

    echo "<div class='col-md-3'>\n";
    $res = $db->consulta("SELECT count(*) FROM fop2buttons");
    $row = $db->fetch_row($res);
    $cont = $row[0];
    echo "<div class='panel panel-info'>\n";
    echo "<div class='panel-heading'><h3 class='panel-title'>".__('Buttons')."</h3></div>\n";;
    echo "<div class='panel-body'><h2 class='text-center'>";
    echo $cont;
    echo "</h2></div>";
    echo "</div>";
    echo "</div>";

    echo "<div class='col-md-3'>\n";
    $res = $db->consulta("SELECT count(*) FROM fop2templates");
    $row = $db->fetch_row($res);
    $cont = $row[0];
    echo "<div class='panel panel-info'>\n";
    echo "<div class='panel-heading'><h3 class='panel-title'>".__('Templates')."</h3></div>\n";;
    echo "<div class='panel-body'><h2 class='text-center'>";
    echo $cont;
    echo "</h2></div>";
    echo "</div>";
    echo "</div>";

    echo "<div class='col-md-3'>\n";
    $res = $db->consulta("SELECT count(*) FROM fop2groups");
    $row = $db->fetch_row($res);
    $cont = $row[0];
    echo "<div class='panel panel-info'>\n";
    echo "<div class='panel-heading'><h3 class='panel-title'>".__('Groups')."</h3></div>\n";;
    echo "<div class='panel-body'><h2 class='text-center'>";
    echo $cont;
    echo "</h2></div>";
    echo "</div>";
    echo "</div>";

    echo "</div>\n";
}
?>

</div>

<div id="upgradeModal" class="modal fade" aria-hidden="true" tabindex="-1" role="dialog">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h3><?php echo __('Please wait...'); ?></h3>
      </div>
      <div class="modal-body">
        <iframe id='modaliframe' src="#" style="width:99.6%; height:200px; border:0;"></iframe>
      </div>
      <div class="modal-footer">
          <button type="button" id='modalclose' class="btn btn-default" data-dismiss="modal"><?php echo __('Close');?></button>
      </div>
    </div>
  </div>
</div>
<div class="push"></div>
</div>
<script>
$('#modalclose').hide();
frameSrc='downloadfile.php?file=<?php echo $adminfile;?>';

$('#upgradeModal').on('show.bs.modal', function () {
    $('iframe').attr("src",frameSrc);
});

$('#upgradeModal').on('hidden.bs.modal', function () {
    window.location.reload();
});

$('#upgradeBtn').click(function(){
   $('#upgradeModal').modal('show');
});

function togglechangelog() {
    $('#changelog').toggle();
    if($('#changelog').is(':visible')) {
        $('#chlogicon').removeClass('glyphicon-collapse-down').addClass('glyphicon-collapse-up');;
        $('#chlogbtn').attr('data-content','<?php echo __('Hide Changelog');?>');
    } else {
        $('#chlogicon').removeClass('glyphicon-collapse-up').addClass('glyphicon-collapse-down');;
        $('#chlogbtn').attr('data-content','<?php echo __('Show Changelog');?>');
    }
}

</script>

<?php

/*
    $results = $db->consulta("SELECT * FROM fop2contexts");
    if($db->num_rows($results)>0) {
        while ($re = $db->fetch_assoc($results)) {
            $contextname[$re['id']]=$re['context'];
            $panelcontext=$re['id'];
            fop2_insert_users();
        }
    }
*/

include("footerbs.php");
