function debug(message) {
    if (window.console !== undefined) {
        console.log(message);
    }
}

function isEmpty( inputStr ) { if ( null == inputStr || '' == inputStr ) { return true; } return false; }

function isInteger ( a ) {  if (a == parseInt(a)) { return true; } return false; }

function fop2_removeSection(el) {
    var partes = el.split("-");
    rawname = partes[1];
    section = partes[2];
    $('#form-'+rawname+'-'+section).remove();
    return false;
}

function fop2_saveConfig(rawname,textok) {
    var mydata = $('#plugin_'+rawname).serialize();
    var myhost = window.location.href;
    $('#statusmodal').modal();
    $.post(myhost,mydata+'&plugin='+rawname+'&action=savePluginConfig',function() {alertify.success(textok); $('#statusmodal').modal('hide');}); 
    return false;
}

function fop2_addConfig(rawname,dest,text,errorexist,errorempty) {

    alertify.prompt(text, function(e, section) {
        // section is the input text
        if (e) {
           section = section.replace(/[^a-z0-9]/gi,'');
           if(section.length==0) {
               alertify.error(errorempty);
               return false;
           }
           if($('#form-'+rawname+'-'+section).length>0) {
               alertify.error(errorexist);
               return false;
           }

           var cloned = $("#form-"+rawname+"-skeleton").clone();
           cloned.find("*[id]").andSelf().each(function() { $(this).attr("id", function (i,id){ var partes = id.split('-'); partes.pop(); return partes.join('-')+'-'+section; }); });
           cloned.find("*[name]").andSelf().each(function() { $(this).attr("name", function (i,name){ if(typeof name != 'undefined') { var partes = name.split('-'); partes.pop(); return partes.join('-')+'-'+section; }}); });
           cloned.find("#legend-"+rawname+"-"+section).html(section);
           cloned.appendTo($('#'+dest));
           $('#form-'+rawname+'-'+section).show();
           set_editable_fields();
           return false;
        }
    },'');
    return false;
}

function setGlobalPlugin(el) {
    if($(el).is(':checked')) { enable=1; } else { enable=0; }
    var partes = $(el).attr('id').split("_");
    var rawname = partes[1];
    var mydata = "action=setglobal&fop2plugin="+rawname+"&fop2globalenabled="+enable;
    var myhost = window.location.pathname;
    $.get(myhost,mydata); 
}

var fixHelper2 = function(e, tr) {
    var originals = tr.children();
    var helper = tr.clone();
    helper.children().each(function(index)
    {
      // Set helper cell sizes to match the original sizes
      $(this).width(originals.eq(index).width())
    });
    return helper;
};

function set_editable_fields() {
    $(".editable").change(function() {
        if($(this).is("select")==true) {
            $(this).blur();
            $(this).focus();
        }
    });

    $(".editable").blur(function() {
        if($(this).val() != $(this).attr('origval')) {
            var mydata = "field="+encodeURIComponent($(this).attr('id'))+"&value="+encodeURIComponent($(this).val().trim())+"&action=saveField";
            var ref=$(this);
            $(this).addClass('loading');
            $('#ajaxstatus').show();
            $.post(window.location.href, mydata, function(data) {
                  if(data.indexOf('ERROR')>0) {
                      ref.effect('highlight',{color:"#D02020"},3000);
                  } else {
                      $('#ajaxstatus').hide();
                      $('#fop2reload').show();
   
                      $('#fop2reload').twinkle( { "effect": "drops", "effectOptions": { color: "rgba(255,0,0,0.5)", radius: 200, duration: 2000, width: 2, count: 10, delay: 700 }});

                      ref.removeClass('loading');
                      ref.animate({backgroundColor: '#BCED91'},200,function() { ref.animate({backgroundColor: '#FFF'},200); } )
                      ref.attr('origval',ref.val().trim());
                      ref.val(ref.attr('origval'));
                  }
            });
        }
    });
}

$(document).ready(function() {

    $('.ttip').popover();
    editfield = '';

    $('#selectlanguage').on('change',function(event,el) {
        setLang(el.selected);
    });

    $('table').each(function() {
        var tableid = this.id;
        if(tableid!='') {
            $("#"+tableid+" tbody").sortable({helper: fixHelper2, update: function(event,ui) { 
                serial = $('#'+tableid+' tbody').sortable('serialize'); 
                var mydata = "action=sort&table="+tableid+"&"+serial;
                $.post(window.location.href,mydata); 
                } 
            });
        }
    });

    $(".editable").each(function() {
        var val = $(this).val();
        if($(this).attr('type') == 'checkbox') {
            if($(this).is(':checked')) {
                val = 1;
                $(this).parents("tr:first").fadeTo('slow',0.5);
            } else {
                val = 0;
            }
            $(this).val(val);
            
        }
        $(this).attr('origval',val);
    });

    set_editable_fields();

    // For auto saving after 4 seconds, on IE (propertychange) and modern browsers (input)
    var propertyChangeUnbound = false;
    $(".editable").on("propertychange", function(e) {
        if (e.originalEvent.propertyName == "value") {
            ref = $(this);
            if(typeof editfield !== "undefined") { clearTimeout(editfield); }
            editfield = setTimeout(function() { ref.blur(); ref.focus();}, 4000);
        }
    });

    $(".editable").on("input", function() {
        if (!propertyChangeUnbound) {
            $(".editable").unbind("propertychange");
            propertyChangeUnbound = true;
        }
        ref = $(this);
        if(typeof editfield !== "undefined") { clearTimeout(editfield); }
        editfield = setTimeout(function() { ref.blur(); ref.focus()}, 4000);
    });

    $('.chosen-select').chosen({disable_search: true, skip_no_results: true});
    $('.chosen-select-100').chosen({disable_search: true, skip_no_results: true, width:'100px'});
    $('.chosen-select-create').chosen({create_option: true, skip_no_results: true});
    $('.dropdown-toggle').dropdown();

    $('table td.clickable').click(function(ev) { partes = ev.currentTarget.id.split("_"); if(partes[0]=='no') { return false; } setEdit(partes[1]); });

});

function setLang(lang) {
    document.cookie='lang='+lang;
    window.location.reload();
}

function setContext(context) {
    document.cookie='context='+context;
    window.location.reload();
}


function fop2Reload() {
    var myhost = 'fop2reload.php';
    $('#statusmodal').modal();
    $.post(myhost,'reload=1',function() {alertify.success(lang['FOP2 Reloaded']); $('#statusmodal').modal('hide'); $('#fop2reload').hide();});
    return false;
}

