<?php
require_once('gettextinc.php');

$version="1.2.4";

set_error_handler("fop2manager_error",E_ALL);

$langs = array();
$langs['en_US']="English";
$langs['es_ES']="Español";

if(isset($_SERVER['PATH_INFO'])) {
    define("SELF",  substr($_SERVER['PHP_SELF'], 0, (strlen($_SERVER['PHP_SELF']) - @strlen($_SERVER['PATH_INFO']))));
} else {
    define("SELF",  $_SERVER['PHP_SELF']);
}

define('PROJECT_DIR', realpath('./'));
define('LOCALE_DIR', PROJECT_DIR .'/i18n');
define('DEFAULT_LOCALE', 'en_US');
define("MYAP", "FOP2Manager");

$encoding = 'UTF-8';

$locale = (isset($_COOKIE['lang']))? $_COOKIE['lang'] : DEFAULT_LOCALE;
$panelcontext = (isset($_COOKIE['context']))? $_COOKIE['context'] : '';
$panelcontext = intval($panelcontext);

T_setlocale(LC_MESSAGES, $locale);
$domain = 'fop2manager';
_bindtextdomain($domain, LOCALE_DIR);
// bind_textdomain_codeset is supported only in PHP 4.2.0+
_bind_textdomain_codeset($domain, $encoding); 
_textdomain($domain);

$predefined_groups = array( 
    array('id' => -1, 'name' =>__("All Buttons")), 
    array('id' => -2, 'name' =>__("All Extensions")),
    array('id' => -3, 'name' =>__("All Queues")), 
    array('id' => -4, 'name' =>__("All Conferences")),
    array('id' => -5, 'name' =>__("All Trunks"))
);

$conf = array();
$conf['DBHOST'] = $DBHOST;
$conf['DBUSER'] = $DBUSER;
$conf['DBPASS'] = $DBPASS;
$conf['DBNAME'] = $DBNAME;

if(is_file("/var/thirdlane_load/pbxportal-ast.sysconfig")) {
    require_once("functions-thirdlane.php");
    $config_engine = 'thirdlane_db';
    $conf = parse_conf("/var/thirdlane_load/pbxportal-ast.sysconfig");
} else
if(is_file("/etc/freepbx/freepbx.conf")) {
    require_once("functions-freepbx.php");
    $config_engine = 'freepbx';
    $conf = parse_conf("/etc/freepbx/freepbx.conf");
} else
if(is_file("/etc/amportal.conf")) {
    require_once("functions-freepbx.php");
    $config_engine = 'freepbx';
    $conf = parse_conf("/etc/amportal.conf");
} else
if(is_file("/etc/asterisk/users.txt")) {
    require_once("functions-thirdlane.php");
    // Old thirdlane requires valid credentials of mysql in config.php
    $config_engine = 'thirdlane_old';
} else {
    require_once("functions-astdb.php");
    $config_engine = "astdb";
}

if(is_file("/usr/local/fop2/fop2.cfg")) {
   $fop2conf = parse_conf("/usr/local/fop2/fop2.cfg");
   if(isset($fop2conf['listenport'])) {
       $conf['fop2port']=$fop2conf['listenport'];
   } else {
       $conf['fop2port']=4445;
   }
   if(isset($fop2conf['manager_port'])) {
       $conf['MGRPORT']=$fop2conf['manager_port'];
   } else {
       $conf['MGRPORT']=5038;
   }
   if(isset($fop2conf['manager_user'])) {
       $conf['MGRUSER']=$fop2conf['manager_user'];
   } else {
       $conf['MGRUSER']=5038;
   }
   if(isset($fop2conf['manager_host'])) {
       $conf['MGRHOST']=$fop2conf['manager_host'];
   } else {
       $conf['MGRHOST']='127.0.0.1';
   }
   if(isset($fop2conf['manager_secret'])) {
       $conf['MGRPASS']=$fop2conf['manager_secret'];
   } else {
       $conf['MGRPASS']=5038;
   }
}

// Number of records per page in users/groups/templates/permissions tables
$perpage=13;

// If this is Elastix, use correct session name
if(is_file("/etc/elastix.conf")) {
    session_name("elastixSession");

    // Set password to be the same as admin in elastix
    $file = file('/etc/elastix.conf');
    foreach ($file as $line) {
        if (preg_match("/^\s*([\w]+)\s*=\s*\"?([\w\/\:\.\*\%!-]*)\"?\s*([;#].*)?/",$line,$matches)) {
            if($matches[1]=='amiadminpwd') {  $ADMINPWD = $matches[2]; };
        }
    }

}

session_start();

if (isset($_SERVER['HTTP_USER_AGENT']) && (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false)) {
    header('X-UA-Compatible: IE=edge,chrome=1');
}

$extramenu=array();

header("Content-type: text/html; charset=$encoding");

