<?php

// Die if we are called via web, we only want to be run from command line
if (php_sapi_name() !='cli') exit;

require_once("config.php");
require_once("functions.php");
require_once("system.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("dbconn.php");

// This script will update all the fop2 tables with information about the system
// This is needed to be run whenever there is a change in the PBX configuration
// or when asterisk is reloaded. So, the same fop2 could run this script on
// RELOAD!!

if($config_engine=='thirdlane_db') {
    $panelcontexts = thirdlane_populate_contexts_from_tenants();
} else {
    $panelcontexts[0]='GENERAL';
}

foreach($panelcontexts as $panelcontext=>$nada) {

    if($panelcontext==0) {
        $wherepanelcontext = '';
    } else {
        $wherepanelcontext = " AND context_id='$panelcontext' ";
    }

    foreach($predefined_groups as $id=>$gdata) {
        $qry = "REPLACE INTO fop2groups (id,name,context_id) values('${gdata['id']}','${gdata['name']}','$panelcontext')";
        $results = $db->consulta($qry);
    }

    $channels     = system_all_values('channel');
    $types        = system_all_values('type');
    $fop2_buttons = fop2_all_buttons();

    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Buttons' $wherepanelcontext";
    $results = $db->consulta($sql);

    // All Extension = -2
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Extensions' $wherepanelcontext";
    $results = $db->consulta($sql);
    foreach($channels as $chan=>$val) {
        if($types[$chan]=='extension') {
            $btid = $fop2_buttons[$val]['devid'];
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Extensions','$btid','$panelcontext')";
            $results = $db->consulta($sql);
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Buttons','$btid','$panelcontext')";
            $results = $db->consulta($sql);
        }
    }

    // All Queues
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Queues' $wherepanelcontext";
    $results = $db->consulta($sql);
    foreach($channels as $chan=>$val) {
        if($types[$chan]=='queue') {
            $btid = $fop2_buttons[$val]['devid'];
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Queues','$btid','$panelcontext')";
            $results = $db->consulta($sql);
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Buttons','$btid','$panelcontext')";
            $results = $db->consulta($sql);
        }
    }

    // All Conferences
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Conferences' $wherepanelcontext";
    $results = $db->consulta($sql);
    foreach($channels as $chan=>$val) {
        if($types[$chan]=='conference') {
            $btid = $fop2_buttons[$val]['devid'];
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Conferences','$btid','$panelcontext')";
            $results = $db->consulta($sql);
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Buttons','$btid','$panelcontext')";
            $results = $db->consulta($sql);
        }
    }

    // All Trunks
    $sql = "DELETE FROM fop2GroupButton WHERE group_name='All Trunks' $wherepanelcontext";
    $results = $db->consulta($sql);
    foreach($channels as $chan=>$val) {
        if($types[$chan]=='trunk') {
            $btid = $fop2_buttons[$val]['devid'];
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Trunks','$btid','$panelcontext')";
            $results = $db->consulta($sql);
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Buttons','$btid','$panelcontext')";
            $results = $db->consulta($sql);
        }
    }

    foreach($channels as $chan=>$val) {
        if($types[$chan]=='park' || $types[$chan]=='ringgroup') {
            $btid = $fop2_buttons[$val]['devid'];
            $sql = "INSERT INTO fop2GroupButton (group_name,id_button,context_id) VALUES ('All Buttons','$btid','$panelcontext')";
            $results = $db->consulta($sql);
        }
    }

    $system_buttons = system_all_buttons();
    if(!isset($fop2_buttons))   { $fop2_buttons = array(); }
    if(!isset($system_buttons)) { $system_buttons = array(); }

    $system_buttons_context = array();
    foreach($system_buttons as $key=>$arradata) {
        if($arradata['context_id']==$panelcontext) {
            $system_buttons_context[$key]=1;
        }
    }

    $del_buttons = array_diff(array_keys($fop2_buttons),array_keys($system_buttons_context));
    $add_buttons = array_diff(array_keys($system_buttons_context),array_keys($fop2_buttons));

    if(!isset($del_buttons)) { $del_buttons = array(); }
    if(!isset($add_buttons)) { $add_buttons = array(); }

    // Remove buttons that are not in the system anymore
    foreach($del_buttons as $chan) {
        $result = $db->select('id,exten','fop2buttons','',"device='$chan'");
        $id     = $result[0]['id'];
        $exten  = $result[0]['exten'];
        fop2_del_button($id,$exten);
    }

    foreach($add_buttons as $chan=>$dat) {

        $det = $system_buttons[$dat];
        $queuechannel   = (isset($det['queuechannel']))?$det['queuechannel']:'';
        $customastdb    = (isset($det['customastdb']))?$det['customastdb']:'';
        $mailbox        = (isset($det['mailbox']))?$det['mailbox']:'';
        $email          = (isset($det['email']))?$det['email']:'';
        $group          = (isset($det['group']))?$det['group']:'';
        $external       = (isset($det['external']))?$det['external']:'';
        $queuecontext   = (isset($det['queuecontext']))?$det['queuecontext']:'';
        $extenvoicemail = (isset($det['extenvoicemail']))?$det['extenvoicemail']:'';
        $context_id     = (isset($det['context_id']))?$det['context_id']:'';


        $results = $db->consulta(
            "REPLACE INTO fop2buttons (type, device, label, exten, context, mailbox, queuechannel, customastdb, email, `group`, external, queuecontext, extenvoicemail, context_id) ".
            "VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s','%s')",
            array($det['type'],$det['channel'],$det['name'],$det['exten'],$det['context'],$mailbox,$queuechannel,$customastdb,$email,$group,$external,$queuecontext,$extenvoicemail,$context_id)
        );
    }

}

if($config_engine=='freepbx') {
    // If we are on FreePBX, then update queuechannel and mailbox automagically
    foreach($system_buttons as $chan=>$dat) {
        if($dat['type']=='extension') {
            $fop2qchan = $fop2_buttons[$chan]['queuechannel'];
            $fop2mbox  = $fop2_buttons[$chan]['mailbox'];
            $fop2qctx  = $fop2_buttons[$chan]['queuecontext'];
            $fop2extv  = $fop2_buttons[$chan]['extenvoicemail'];
            if($fop2qchan <> $dat['queuechannel']) {
                $query = "UPDATE fop2buttons SET queuechannel='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['queuechannel'],$chan));
                $need_update=1;
            }
            if($fop2mbox <> $dat['mailbox']) {
                $query = "UPDATE fop2buttons SET mailbox='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['mailbox'],$chan));
                $need_update=1;
            }
            if($fop2qctx <> $dat['queuecontext']) {
                $query = "UPDATE fop2buttons SET queuecontext='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['queuecontext'],$chan));
                $need_update=1;
            }
            if($fop2extv <> $dat['extenvoicemail']) {
                $query = "UPDATE fop2buttons SET extenvoicemail='%s' WHERE device='%s'";
                $db->consulta($query,array($dat['extenvoicemail'],$chan));
                $need_update=1;
            }

        }
    }
}

plugin_insert_missing_db();

// Execute php update script for plugins if they exists
$dir = dirname(__FILE__);
$pepe = get_installed_plugins();
foreach($pepe as $plugname=>$val) {
    $updatescript = $dir."/plugins/$plugname/update_conf.php";
    if(is_file($updatescript)) {
        system("php -f $updatescript");
    }
}
